VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Private m_oForm As desktop.frmDesktop

Private mWndProcOrg As Long
Private mHWndSubClassed As Long
Private m_sName As String
Public Function IBasePlugin_StartPlugin(Name As String) As Long
    
    Dim top As Long
    Dim left As Long
    Dim right As Long
    Dim bottom As Long
    
    Set oServer = CreateObject("core.CServer")
    Set m_oForm = New desktop.frmDesktop
    
    m_sName = Name
    m_oForm.Tag = Name
    
    left = oServer.evalNum(oServer.GetKey(Name, "left"))
    top = oServer.evalNum(oServer.GetKey(Name, "top"))
    right = oServer.evalNum(oServer.GetKey(Name, "right"))
    bottom = oServer.evalNum(oServer.GetKey(Name, "bottom"))

    SetDesktopArea left, top, right, bottom
    
    If oServer.evalBool(oServer.GetKey(Name, "runonce")) Then
        StartUp True
    End If
    
    If oServer.evalBool(oServer.GetKey(Name, "run")) Then
        StartUp False
    End If
    
    If oServer.evalBool(oServer.GetKey(Name, "startup")) Then
    
        Dim sPath As String
        Dim textline As String
        
        If fGetSystemFolderPath(m_oForm.Hwnd, CSIDL_STARTUP, sPath) Then
        
            textline = Dir(sPath & "\*.*")
            While textline <> ""
                oServer.Execute "!log Starting " & textline
                oServer.Execute sPath & "\" & textline
                textline = Dir
            Wend
        
        End If
    
        If fGetSystemFolderPath(m_oForm.Hwnd, CSIDL_COMMON_STARTUP, sPath) Then
        
            textline = Dir(sPath & "\*.*")
            While textline <> ""
                oServer.Execute "!log Starting " & textline
                oServer.Execute sPath & "\" & textline
                textline = Dir
            Wend
        
        End If
    
    End If
    
    oServer.SetDesktop m_oForm.Hwnd
    oServer.Execute "!log Registered " & Name & " as the desktop window"
    DragAcceptFiles m_oForm.Hwnd, True
    SubClass
    m_oForm.Visible = True
    IBasePlugin_StartPlugin = m_oForm.Hwnd
    

End Function
Private Sub IBasePlugin_StopPlugin()
    
    frmDesktop.Visible = False
    DragAcceptFiles m_oForm.Hwnd, False
    UnSubClass
    Call Unload(frmDesktop)

End Sub
Public Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)
   
End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Private Sub SubClass()
   '-------------------------------------------------------------
   'Initiates the subclassing of this UserControl's window (hwnd).
   'Records the original WinProc of the window in mWndProcOrg.
   'Places a pointer to the object in the window's UserData area.
   '-------------------------------------------------------------

   'Exit if the window is already subclassed.
   If mWndProcOrg Then Exit Sub

      'Redirect the window's messages from this control's default
      'Window Procedure to the SubWndProc function in your .BAS
      'module and record the address of the previous Window
      'Procedure for this window in mWndProcOrg.
      mWndProcOrg = SetWindowLong(m_oForm.Hwnd, GWL_WNDPROC, AddressOf SubWndProc)

      'Record your window handle in case SetWindowLong gave you a
      'new one. You will need this handle so that you can unsubclass.
      mHWndSubClassed = m_oForm.Hwnd

      'Store a pointer to this object in the UserData section of
      'this window that will be used later to get the pointer to
      'the control based on the handle (hwnd) of the window getting
      'the message.
      Call SetWindowLong(m_oForm.Hwnd, GWL_USERDATA, ObjPtr(Me))

End Sub
Private Sub UnSubClass()
   
   '-----------------------------------------------------------
   'Unsubclasses this UserControl's window (hwnd), setting the
   'address of the Windows Procedure back to the address it was
   'at before it was subclassed.
   '-----------------------------------------------------------

   'Ensures that you don't try to unsubclass the window when
   'it is not subclassed.
   If mWndProcOrg = 0 Then Exit Sub

   'Reset the window's function back to the original address.
   SetWindowLong mHWndSubClassed, GWL_WNDPROC, mWndProcOrg
   '0 Indicates that you are no longer subclassed.
   mWndProcOrg = 0

End Sub
Friend Function WindowProc(ByVal Hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   '--------------------------------------------------------------
   'Process the window's messages that are sent to your UserControl.
   'The WindowProc function is declared as a "Friend" function so
   'that the .BAS module can call the function but the function
   'cannot be seen from outside the UserControl project.
   '--------------------------------------------------------------

    Dim WP As WINDOWPOS
    Dim sCommand As String
    Dim sTemp As String
    Dim n As Long
    Dim iLoop As Long
    Dim p As POINTAPI
    Dim length As Long
    
    Select Case uMsg
        Case WM_WINDOWPOSCHANGING
            CopyMemorySrcAddr WP, lParam, LenB(WP)
            WP.hWndInsertAfter = HWND_BOTTOM
            CopyMemoryDestAddr lParam, WP, LenB(WP)
        
        Case WM_LBUTTONDOWN
            sCommand = oServer.GetKey(m_sName, "lbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_LBUTTONUP
            sCommand = oServer.GetKey(m_sName, "lbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_LBUTTONDBLCLK
            sCommand = oServer.GetKey(m_sName, "lbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_RBUTTONDOWN
            sCommand = oServer.GetKey(m_sName, "rbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_RBUTTONUP
            sCommand = oServer.GetKey(m_sName, "rbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_RBUTTONDBLCLK
            sCommand = oServer.GetKey(m_sName, "rbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_MBUTTONDOWN
            sCommand = oServer.GetKey(m_sName, "mbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_MBUTTONUP
            sCommand = oServer.GetKey(m_sName, "mbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
        
        Case WM_MBUTTONDBLCLK
            sCommand = oServer.GetKey(m_sName, "mbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            
        Case WM_DROPFILES
            n = DragQueryFile(wParam, -1&, vbNullString, 0)
            DragQueryPoint wParam, p
            For iLoop = 0 To n - 1
                sTemp = String(1024, 0)
                length = DragQueryFile(wParam, iLoop, sTemp, Len(sTemp))
                If length > 0 Then
                    sCommand = left(sTemp, length)
                    If LCase(right(sCommand, 3)) = "dll" Then
                        If oServer.LoadPlugin("", sCommand) = 0 Then
                            oServer.Execute "!log Loaded module " & sCommand
                        Else
                            oServer.Execute "!log This file isn't a core module"
                        End If
                    End If
                    oServer.Execute "!log dropped " & sCommand & " onto " & m_sName & " at x=" & p.x & " and y=" & p.y
                End If
            Next
            DragFinish wParam 'wParam
    End Select
   
    'Forwards the window's messages that came in to the original
    'Window Procedure that handles the messages and returns
    'the result back to the SubWndProc function.
    WindowProc = CallWindowProc(mWndProcOrg, m_oForm.Hwnd, uMsg, wParam, ByVal lParam)

End Function
